﻿@{ Layout = null; }
<!DOCTYPE html>
<html>
<head>
    <title>Memory</title>
    <script src="@Url.Content("~/Scripts/Common/jquery.js")" type="text/javascript"></script>
    <script src="@Url.Content("~/Scripts/Common/jquery.dataTables.min.js")" type="text/javascript"></script>
    <script type="text/javascript" >
        var level = 0;
        function lick(t) {
            
            var o = t.textContent;
            
            $("#q").val(o);
            ListButtonClick();
        }
        function ListButtonClick(s, e) {
            var q = $("#q").val();
            level = (!(q) || (q == "" || q == undefined || q == null)) ? 0 : 1;

            $.ajax({
                type: "GET",
                url: "Memory/List",
                data: { q: q },
                success: function (x, h, r) {
                    var res = "";
                    var ire = 0;

                    var ret = x.split(",");

                    if (level <= 0) ret.sort();

                    ++level;
                    var additive = "";
                    if (level <= 1) {
                        additive = " onclick=\"lick(this)\"";

                        if (x.length > 0 && ret.length > 0) {
                            res = "<ul>";
                            ret.forEach(function (a, i) {
                                if (a.indexOf("COUNT.") < 0)
                                    res += ((ire++ > 0) ? "\r\n" : "") + "<li" + additive + ">" + a + "</li>";
                            });
                            res += "<ul>";
                        }
                    }
                    else {
                        res = "<pre>" + x + "</pre>";
                    }

                    $("#scr").html(res);
                },
                fail: function (x, h, r) {
                    $("#scr").html("Error Listing " + x);
                },
                error: function (x, h, r) {
                    $("#scr").html("Error!");
                }
            });
        }
        function CountButtonClick(s, e) {
             $("#scr").html("Count");
            var q = $("#q").val();
            level = (!(q) || (q == "" || q == undefined || q == null)) ? 0 : 1;

            $.ajax({
                type: "GET",
                url: "Memory/Count",
                data: { q: q },
                success: function (x, h, r) {
                    var res = "";
                    var ire = 0;
                    var ret = x.split(",");
                    ++level;
                    var additive = "";
                    if (level <= 1) {
                        additive = " onclick=\"lick(this)\"";
                        if (x.length > 0 && r.length > 0) {
                            res = "<ul>";
                            ret.forEach(function (a, i) {                                
                                    res += ((ire++ > 0) ? "\r\n" : "") + "<li " + additive + ">" + a + "</li>";
                            });
                            res += "<ul>";
                        }
                    } else {
                        res = x;
                    }
                    $("#scr").html(res);
                },
                fail: function (x, h, r) {
                    $("#scr").html("Error count " + x);
                },
                error: function (x, h, r) {
                    $("#scr").html("Error!!");
                }
            });
        
         }
         function DeleteButtonClick(s, e) {
             $("#scr").html("Delete");
             var q = $("#q").val();
             if (!(q) || q == "" || q == null || q == undefined)
                if (!confirm("Wipe all memory cache?")) return;
            $.ajax({
                type: "GET", 
                url: "Memory/Del",
                data: { q: $("#q").val() },
                success: function(x,h,r) {
                    $("#scr").html(x.replaceAll(",", "<br/>"));
                }, 
                fail: function(x,h,r) {
                    $("#scr").html("Error deleting " + x);
                },
                error: function (x, h, r) {
                    $("#scr").html("Error!!!");
                }
            });

        }

        function xButtonClick(s, e) {
            $("#q").val(null);
            $("#scr").html("");
            ListButtonClick();
        }
        $(function (x) {
            $("#CountButton").hide();
        });
    </script>
</head>
<body>
    <div id="buttons" class="row">
        <button id="ListButton" onclick="ListButtonClick()">List</button>
        <input type="text" id="q"/><button id="xButton" onclick = "xButtonClick()">Reset</button>
        <button id="CountButton" onclick="CountButtonClick()">Count</button>
        <button id="DeleteButton" name="del" value="0" onclick="DeleteButtonClick()">Delete</button>
    </div>
    <div id="scr">
        
    </div>
</body>
</html>
